<?php
/*
2chBBS Admin makes managing 2chBBS much easier!
Copyright (C) 2008 Tetsuya Saito
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function plugin_bbsadmin_init() {
	// 2chBBS のあるディレクトリ
	define('BBS_DIR_NAME', '2chBBS' );
	define('BBS_HOME', PLUGIN_DIR . BBS_DIR_NAME . '/');
	// 設定ファイルの読み込み
	include_once(BBS_HOME . 'bbsadmin.ini.php');
	// セッションをスタート
	session_start();
}

// function plugin_bbsadmin_convert() { return plugin_bbsadmin_action(); }

function plugin_bbsadmin_action(){
	global $script, $vars, $get, $post;
	global $_msg_invalidpass;
	$msg = '2chBBS Admin';
	$body = BBSADMIN_LOGO;
	$pass = isset($post['pass']) ? $post['pass'] : NULL;
	if($pass != NULL && pkwk_login($pass)) $_SESSION[COOKIE] = 1;
	if(!isset($_SESSION[COOKIE]) || $_SESSION[COOKIE] != 1){
		if(!file_exists(BBS_HOME . 'BBSADMIN.LICENSE.html')){
			if(!isset($post['license'])){
				$body .= '<h3>使用許諾書（GNUv3）</h3>
				<iframe src="http://buffalowiki.staba.jp/BBSADMIN/LICENSE.UTF-8.html" width="97%" height="50%"></iframe>
				<form method="post"><p><ul><li>使用許諾書に同意しますか？ 
				<input type="submit" name="license" value="同意する">
				<input type="submit" name="license" value="同意しない">
				</li></ul></p></form>';
				$body .= COPY;
				return array('msg'=>$msg, 'body'=>$body);
			} else {
				switch($post['license']){
				case '同意する':
					if(file_exists(BBS_HOME . 'BBSADMIN.LICENSE.html')) unlink(BBS_HOME . 'BBSADMIN.LICENSE.html');
					copy('http://buffalowiki.staba.jp/BBSADMIN/LICENSE.UTF-8.html', BBS_HOME . 'BBSADMIN.LICENSE.html');
				break;
				default:
					if(isset($_SESSION[COOKIE])) unset($_SESSION[COOKIE]);
					if(file_exists(BBS_HOME . 'BBSADMIN.LICENSE.html')) unlink(BBS_HOME . 'BBSADMIN.LICENSE.html');
					$body .= '<span style="color:#F00;font-weight:bold">使用許諾書への同意が拒否されました。</span>';
					$body .= COPY;
					return array('msg'=>$msg, 'body'=>$body);
				}
			}
		}
		$msg .= ' - Login';
		$body = ($pass === NULL) ? BBSADMIN_LOGIN_LOGO : BBSADMIN_LOGO . '<span style="color:#F00;font-weight:bold">' . $_msg_invalidpass . '</span>';
		$body .= '<form method="post">
		<p><b>管理者パスワード：</b>
		<input type="hidden" name="page" value="' . htmlspecialchars($get['page']) . '" />
		<input type="password" name="pass" size="12" />
		<input type="submit" value="ログイン" /></p>
		<font size="-1">PHP version ' . PHP_VERSION . ' &mdash; SQLite version ' . get_sqlite_version() . '</font>
		</form>';
		$body .= COPY;
		return array('msg'=>$msg, 'body'=>$body);
	}

	if(isset($post['action'])){
		switch($post['action']){
		case 'ログアウト':
			unset($_SESSION[COOKIE]);
			setcookie( COOKIE . '-delete', '', 0);
			$body .= '<strong>ログアウトしました。</strong>';
			// Donateのアイコンを外したい場合は$donateをコメントアウトして下さい。
			/*$donate = '<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<input type="hidden" name="cmd" value="_s-xclick">
			<input type="hidden" name="hosted_button_id" value="97199">
			<input type="image" src="https://www.paypal.com/en_US/JP/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="">
			<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
			</form>';
			$body .= $donate . COPY;*/
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case 'この書き込みを修正する':
			$bbs = $post['bbs'];
			$bbspath = $post['bbspath'];
			$kdate = $post['kdate'];
			$num = $post['num'];
			$thread = $post['thread'];
			$dcom = mb_ereg_replace("\n", BR, $post['dcom']);
			$body .= delete_comment($bbs, $bbspath, $kdate, $num, $dcom, RES);
			$body .= '<form method="post">
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			<input type="hidden" name="kdate" value="' . $kdate . '">
			<input type="hidden" name="thread" value="' . $thread . '">
			<p><input type="submit" value="書き込みの選択画面へ戻る"></p>
			</form>
			<hr>
			<form method="post">
			<p><input type="submit" value="スレッドの選択画面へ戻る" /></p>
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			</form>
			<hr>
			<form method="post"><p><input type="submit" value="掲示板の選択画面へ戻る" /></p></form>
			<hr>
			<form method="post"><p><input type="submit" name="action" value="ログアウト" /></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case 'この書き込みを消去する':
			$bbs = $post['bbs'];
			$bbspath = $post['bbspath'];
			$kdate = $post['kdate'];
			$num = $post['num'];
			$thread = $post['thread'];
			if($post['default'] == 0) $dcom = $post['dcom'];
			else $dcom = DELETED_COM;
			$body .= delete_comment($bbs, $bbspath, $kdate, $num, $dcom, DELETED);
			$body .= '<form method="post">
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			<input type="hidden" name="kdate" value="' . $kdate . '">
			<input type="hidden" name="thread" value="' . $thread . '">
			<p><input type="submit" value="書き込みの選択画面へ戻る"></p>
			</form>
			<hr>
			<form method="post">
			<p><input type="submit" value="スレッドの選択画面へ戻る" /></p>
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			</form>
			<hr>
			<form method="post"><p><input type="submit" value="掲示板の選択画面へ戻る" /></p></form>
			<hr>
			<form method="post"><p><input type="submit" name="action" value="ログアウト" /></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case 'アップロード':
			$bbspath = $post['bbspath'];
			$conf = $bbspath . 'conf.inc.php';
			if($_FILES['conf']['name'] == ''){
				$body .= '<span style="color:#F00;font-weight:bold">アップロードするファイルがありません。</span>';
				unset($post['action']);
			} elseif( (!file_exists($conf . '~') || unlink($conf . '~'))
			&& copy($conf, $conf . '~') && unlink($conf) && copy($_FILES['conf']['tmp_name'], $conf)) {
				chmod($conf, 0644);
				$body .= '<strong>アップロードしました。</strong>';
			} else {
				$body .= '<span style="color:#F00;font-weight:bold">アップロードできませんでした。</span>';
				unset($post['action']);
			}
			break;
		case 'このスレッド全体を削除する':
			$bbs = $post['bbs'];
			$bbspath = $post['bbspath'];
			$kdate = $post['kdate'];
			$thread = $post['thread'];
			$body .= '<h3>削除するスレッドの情報</h3><b>掲示板名：</b>' . $bbs . '<br />' . '<b>スレッド名：</b>' . $thread .
			'<br /><b>ファイルサイズ：</b>' . filesize($bbspath . DAT . '/' . $kdate) . ' バイト
			<p><a href="' . $vars['page'] . '?cmd=bbsadmin&text=' . $bbspath . DAT . '/' . $kdate . '" target="_blank">ファイルをダウンロード</a></p>
			<hr>
			<form method="post"><p>
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			<input type="hidden" name="kdate" value="' . $kdate . '">
			<input type="submit" name="action" value="スレッドの削除を実行する"> 
			<input type="submit" value="キャンセル">
			</p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case 'スレッドの削除を実行する':
			$bbs = $post['bbs'];
			$bbspath = $post['bbspath'];
			$kdate = $post['kdate'];
			$body .= delete_thread($bbspath, $kdate) . '
			<hr>
			<form method="post">
			<input type="hidden" name="bbs" value="' . $bbs . '">
			<input type="hidden" name="bbspath" value="' . $bbspath . '">
			<p><input type="submit" value="スレッドの選択画面へ戻る" /></p></form>
			<hr>
			<form method="post"><p><input type="submit" value="掲示板の選択画面へ戻る" /></p></form>
			<hr>
			<form method="post"><p><input type="submit" name="action" value="ログアウト" /></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case '新しい掲示板を設置する':
			$body .= '<form method="post"><h3>新しい掲示板の設置</h3>
			<p><b>掲示板のディレクトリ名</b>：<input type="text" name="newbbs" /> <input type="submit" value="実行" /></p>
			</form>
			<hr>
			<form method="post"><p><input type="submit" value="キャンセル"></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case '掲示板の削除':
			$body .= '<form method="post"><h3>掲示板の削除</h3>
			<select name="deleteBBS"><option value=""> - 削除する掲示板を選択 - </option>';
			$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
			$query = sqlite_query($con, 'SELECT * FROM ' . TABLE_NAME . ' ORDER BY PATH');
			sqlite_close($con);
			while( $line = sqlite_fetch_array($query, SQLITE_NUM) ) {
				$body .= '<option value="' . $line[0] . SPL . $line[1] . '">' . $line[1] . '</option>';
			}
			$body .= '</select><p><input type="submit" value="次へ進む"></p></form>
			<hr><form method="post"><p><input type="submit" value="キャンセル"></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case '掲示板の削除を実行する':
			$bbspath = $post['bbspath'];
			if(file_exists($bbspath . DAT)){
				$dir = dir($bbspath . DAT);
				while (false !== ($line = $dir->read())) {
					if($line != '.' && $line != '..'){
						unlink($bbspath . DAT . '/' . $line);
					}
				}
				$dir->close();
			}
			if(rmdir($bbspath . DAT) && file_exists($bbspath)){
				$dir = dir($bbspath);
				while (false !== ($line = $dir->read())) {
					if($line != '.' && $line != '..'){
						if($bbspath != PLUGIN_DIR . BBS_DIR_NAME . '/') unlink($bbspath . $line);
						elseif($line != '.htaccess') unlink($bbspath . $line);
					}
				}
				$dir->close();
			}
			$rmdir = FALSE;
			if($bbspath != PLUGIN_DIR . BBS_DIR_NAME . '/') $rmdir = rmdir($bbspath);
			else $rmdir = file_exists($bbspath . DAT);
			$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
			if($con && $rmdir){
				sqlite_exec($con, 'DELETE FROM ' . TABLE_NAME . ' WHERE PATH = "' . $bbspath . '"');
				$body .= '<strong>掲示板は削除されました。</strong>';
			} else {
				$body .= '<span style="color:#F00;font-weight:bold">削除できませんでした。</span>';
			}
			sqlite_close($con);
			$body .= '<hr>
			<form method="post">
			<p><input type="submit" value="掲示板の選択画面へ戻る" /></p>
			</form>
			<hr>
			<form method="post">
			<p><input type="submit" name="action" value="ログアウト" /></p>
			</form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		case '整合性をチェック':
			$body .= check_db() . '<hr><form method="post"><p><input type="submit" value="掲示板の選択画面へ戻る" /></p></form>
			<hr>
			<form method="post"><p><input type="submit" name="action" value="ログアウト" /></p></form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		}
	}

	if(isset($post['newbbs'])){
		$newbbs = $post['newbbs'];
		$newbbs_home = BBS_HOME . $newbbs . '/';
		$table = '<table>';
		if(!file_exists($newbbs_home)){
			if(mkdir($newbbs_home)) $table .= '<tr><td><b>' . $newbbs_home . '</b></td></tr>';
			$fp = @fopen($newbbs_home . '.htaccess', 'w');
			if(fwrite($fp, "Order allow,deny\n") && fwrite($fp, 'Deny from all')) $table .= '<tr><td> - .htaccess</td></tr>';
			fclose($fp);
			if(copy(BBS_HOME . CONF_FILE, $newbbs_home . 'conf.inc.php')) $table .= '<tr><td> - conf.inc.php</td></tr>';
			if(touch($newbbs_home . LAST_SIZE)) $table .= '<tr><td> - ' . LAST_SIZE . '</td></tr>';
			if(touch($newbbs_home . BACKUP_FILE)) $table .= '<tr><td> - ' . BACKUP_FILE . '</td></tr>';
			if(touch($newbbs_home . SUBJECT_FILE)) $table .= '<tr><td> - ' . SUBJECT_FILE . '</td></tr>';
			if(mkdir($newbbs_home . DAT)) $table .= '<tr><td><b>' . $newbbs_home . DAT . '/</b></td></tr>';
			if(copy($newbbs_home . '.htaccess', $newbbs_home . DAT . '/.htaccess')) $table .= '<tr><td> - ' . '.htaccess</td></tr>';
			$table .= '</table>';
			chmod($newbbs_home, 0777);
			chmod($newbbs_home . DAT, 0777);
			chmod($newbbs_home . 'conf.inc.php', 0644);
			chmod($newbbs_home . LAST_SIZE, 0666);
			chmod($newbbs_home . BACKUP_FILE, 0666);
			chmod($newbbs_home . SUBJECT_FILE, 0666);
			chmod($newbbs_home . 'conf.inc.php', 0644);
			chmod($newbbs_home . '.htaccess', HTACCESS);
			chmod($newbbs_home . DAT . '/.htaccess', HTACCESS);
			$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
			sqlite_exec($con, 'INSERT INTO ' . TABLE_NAME . ' VALUES ("' . $newbbs_home . '", "' . $newbbs .'")');
			sqlite_close($fp);
		 	$body .= '<strong>新しい掲示板が設置されました。</strong><h3>作成されたファイルとフォルダ</h3>' . $table . '<hr>
			<form method="post">
			<p><input type="submit" value="掲示板の選択画面へ戻る" /></p>
			</form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		 } else {
		 	$body .= '<span style="color:#F00;font-weight:bold">同じ名前のディレクトリが存在します。</span>
			<hr>
			<form method="post">
			<p><input type="submit" value="掲示板の選択画面へ戻る" /></p>
			</form>';
			$body .= COPY;
			return array('msg'=>$msg, 'body'=>$body);
		}
	}
	
	if(isset($post['deleteBBS'])){
		$BBS = explode(SPL, $post['deleteBBS']);
		$bbspath = $BBS[0];
		$bbs = $BBS[1];
		$str = '';
		$i = 0;
		$body .= '<h3>削除する掲示板の情報</h3><b>掲示板名：</b>' . $bbs . '<br>
		<form method="post"><p>
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		<input type="submit" name="action" value="掲示板の削除を実行する"> 
		<input type="submit" value="キャンセル">
		</p></form>
		<hr>';
		if(file_exists($bbspath . SUBJECT_FILE)) $fp = @fopen($bbspath . SUBJECT_FILE, 'r');
		if($fp){
			while (!feof($fp)) {
				$line = fgets($fp);
				$line = explode(SPL, $line);
				if($line[0] != ''){
					$str .= $line[1] . ' - ' . round(filesize($bbspath . DAT . '/' . $line[0])/1000,1) . ' KB - 
					<a href="' . $vars['page'] . '?cmd=bbsadmin&text=' . $bbspath . DAT . '/' . $line[0] . '" target="_blank">ファイルをダウンロード</a>
					<br />';
					$i++;
				}
			}
		}
		fclose($fp);
		if($str == '') $body .= '<span style="color:#F00;font-weight:bold">立てられているスレッドがありません</span>';
		else $body .= '<b>立てられているスレッドの一覧（' . $i . '件）</b>
		<p><a href="' . $vars['page'] . '?cmd=bbsadmin&text=' . $bbspath . SUBJECT_FILE . '" target="_blank">サブジェクトファイルをダウンロード</a></p>
		<p>' . $str . '</p>';

		$body .= '<hr><form method="post"><p>
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		<input type="submit" name="action" value="掲示板の削除を実行する"> 
		<input type="submit" value="キャンセル">
		</p></form>
		<hr><form method="post"><p><input type="submit" name="action" value="ログアウト" /></p></form>';
		$body .= COPY;
		return array('msg'=>$msg, 'body'=>$body);
	}
	
	if(isset($get['text'])){
		$text = $get['text'];
		$fp = fopen($text, 'r');
		$body = '';
		while (!feof($fp)) {
			$line = fgets($fp);
			$body .= (TO_ENC == FROM_ENC)? $line :  mb_convert_encoding($line, TO_ENC, FROM_ENC);
			$body .= BR;
		}
		fclose($fp);
		die($body);
	}
	
	if((isset($post['BBS']) || isset($post['bbs'])) && !isset($post['kdate'])){
		if(isset($post['BBS'])){
			$BBS = explode(SPL, $post['BBS']);
			$bbspath = $BBS[0];
			$bbs = $BBS[1];
		} else {
			$bbspath = $post['bbspath'];
			$bbs = $post['bbs'];
		}
		$body  .= '<h3>スレッドの選択</h3><b>掲示板名：' . $bbs . '</b>
		<form method="post">
		<p><input type="submit" value="掲示板の選択画面へ" /></p>
		</form>
		<hr>
		<form method="post" enctype="multipart/form-data">
		<b>設定ファイルをアップロード：</b><input type="file" name="conf"> 
		<input type="submit" name = "action" value="アップロード" />
		<p><b>現在の設定：</b>';
		if($post['showConf'] == '表示する' || $post['action'] == 'アップロード') $body .=
		'<input type="submit" name = "showConf" value="表示を隠す" />' . get_conf($bbspath);
		else $body .= '<input type="submit" name = "showConf" value="表示する" />';
		$body .= '</p><hr>
		<p><input type="submit" value="このスレッドを選択する" /></p>' . get_thread($bbs, $bbspath) . '<p>
		<input type="submit" value="このスレッドを選択する" /></p>
		<input type="hidden" name="bbs" value="' . $bbs . '">
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		</form>
		<hr><form method="post">
		<p><input type="submit" value="掲示板の選択画面へ" /></p>
		</form>
		<hr>
		<form method="post">
		<p><input type="submit" name="action" value="ログアウト" /></p>
		</form>';
	} elseif(isset($post['bbs']) && isset($post['kdate']) && !isset($post['num'])) {
		$bbs = $post['bbs'];
		$bbspath = $post['bbspath'];
		$kdate = $post['kdate'];
		$thread = $post[str_replace('.' . DAT, '', $kdate)];
		$st = !isset($post['st']) ? 1 : $post['st'];
		$ls = !isset($post['ls']) ? 20 : $post['ls'];
		$body .= '<h3>消去する書き込みの選択</h3>';
		$body .= '<b>掲示板名：' . $bbs . '<br />スレッド名：' . $thread . '</b>
		<form method="post">
		<p><input type="submit" value="スレッドの選択画面へ" /></p>
		<input type="hidden" name="bbs" value="' . $bbs . '">
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		</form>
		<hr>
		<form method="post">
		<input type="hidden" name="bbs" value="' . $bbs . '">
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		<input type="hidden" name="kdate" value="' . $kdate . '">
		<input type="hidden" name="thread" value="' . $thread . '">
		<input type="submit" name="action" value="このスレッド全体を削除する" /></p>
		</form>
		<hr>';
		$body .= '<form method="post">
		<p><input type="text" size="4" name="st" value="' . $st . '"> 件目から最大 
		<select name="ls">';
		switch($ls){
			case 10:
				$body .= '<option selected>10</option>
				<option>20</option>
				<option>30</option>
				<option>50</option>
				<option>100</option>';
			break;
			case 30:
				$body .= '<option>10</option>
				<option>20</option>
				<option selected>30</option>
				<option>50</option>
				<option>100</option>';
			break;
			case 50:
				$body .= '<option>10</option>
				<option>20</option>
				<option>30</option>
				<option selected>50</option>
				<option>100</option>';
			break;
			case 100:
				$body .= '<option>10</option>
				<option>20</option>
				<option>30</option>
				<option>50</option>
				<option selected>100</option>';
			break;
			default:
				$body .= '<option>10</option>
				<option selected>20</option>
				<option>30</option>
				<option>50</option>
				<option>100</option>';
		}
		$body .= '</select> 件を表示 <input type="submit" value="実行"></p>
		<input type="hidden" name="bbs" value="' . $bbs . '">
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		<input type="hidden" name="kdate" value="' . $kdate . '">
		<input type="hidden" name="thread" value="' . $thread . '">
		</form>';
		$body .= get_comment($bbs, $bbspath, $kdate, $thread, $st, $ls);
		$body .= '<hr>
		<form method="post">
		<p><input type="submit" value="スレッドの選択画面へ" /></p>
		<input type="hidden" name="bbs" value="' . $bbs . '">
		<input type="hidden" name="bbspath" value="' . $bbspath . '">
		</form>
		<hr>
		<form method="post">
		<p><input type="submit" name="action" value="ログアウト" /></p>
		</form>';
	} elseif(isset($post['bbs']) && isset($post['kdate']) && isset($post['num'])) {
		$bbs = $post['bbs'];
		$bbspath = $post['bbspath'];
		$kdate = $post['kdate'];
		$num = $post['num'];
		$thread = $post['thread'];
		$action = $post['action'];
		$body  .= '<h3>消去する書き込みの確認と実行</h3>';
		$body .= '<b>掲示板名：' . $bbs . '<br />スレッド名：' . $thread . '</b>';
		$body .= get_one_comment($bbs, $bbspath, $kdate, $num, $thread, $action);
	
	} else {
		$table = open_db($post['newbbs'], $post['newname'], $post['path']);
		$body  .= '<h3>掲示板の選択</h3>
		<form method="post">
		<p><input type="submit" name="action" value="新しい掲示板を設置する" />
		<input type="submit" name="action" value="掲示板の削除" />
		<input type="submit" name="action" value="整合性をチェック" /></p>
		</form>
		<hr>
		<form method="post">
		<p><input type="submit" value="この掲示板を選択する" /></p>' .  $table . '<p><input type="submit" value="この掲示板を選択する" /></p>
		</form>
		<hr>
		<form method="post">
		<p><input type="submit" name="action" value="ログアウト" /></p>
		</form>';
	}
	$body .= COPY;
	return array('msg'=>$msg, 'body'=>$body);
}

function open_db($newbbs = '', $newname = '', $path = ''){
	if( !file_exists(ADMIN_SQLITE) ){
		$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
		sqlite_exec($con, 'CREATE TABLE ' . TABLE_NAME . ' (PATH TEXT UNIQUE NOT NULL PRIMARY KEY, BBS TEXT NOT NULL)');
		$dir = dir(BBS_HOME);
		while (FALSE !== ($line = $dir->read())) {
			if(is_dir(BBS_HOME . $line) && $line != '.' && $line != '..' && $line != DAT){
				sqlite_exec($con, 'INSERT INTO ' . TABLE_NAME . ' VALUES ("' . BBS_HOME . $line . '/", "' . $line .'")');
			} elseif($line == DAT) {
				sqlite_exec($con, 'INSERT INTO ' . TABLE_NAME . ' VALUES ("' . BBS_HOME . '", "' . BBS_DIR_NAME .'")');
			}
		}
		$dir->close();
		sqlite_close($con);
	}
	$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
	if($con){
		if(BBSCAT != '') $wiki = rawurlencode(BBSCAT) . '/';
		else $wiki = '';
		if($newname != '') sqlite_exec($con, 'UPDATE ' . TABLE_NAME . ' SET BBS = "' . $newname . '" WHERE PATH = "' . $path . '"');
		$query = sqlite_query($con, 'SELECT * FROM ' . TABLE_NAME . ' ORDER BY PATH');
		sqlite_close($con);
		$str ='<tr><td colspan="2"><b>フォルダ名</b></td><td><b>ウィキ上の掲示板名</b></td><td></td><td><b>新しい掲示板名</b></td></tr>';
		while( $line = sqlite_fetch_array($query, SQLITE_NUM) ) {
			
			$url = 'http://buffalowiki.staba.jp/?cmd=read&page=' . $wiki . urlencode($line[1]);
			$str .= '<tr><td><input type="radio" name="BBS" value="' . $line[0] . SPL . $line[1] . '"></td>
			<td nowrap><span style="margin-right:10px">' . $line[0] . '</span></td><td nowrap>' . $line[1] . '</td>
			<td><span style="margin-left:10px;margin-right:10px">>></span></td><td nowrap>
			<form method="post">
			<input type="text" name="newname">
			<input type="hidden" name="path" value="' . $line[0] . '">
			<span style="margin-right:10px"><input type="submit" value="変更"></span>
			</form></td><td nowrap> - <a href="' . $url . '" target="_blank">掲示板を表示</a></td></tr>';
		}
	} else {
		$str = '<span style="color:#F00;font-weight:bold">データベースへの接続に失敗しました。</span>';
	}
	return '<table cellspacing="3">' . $str . '</table>';
}

function get_thread($bbs, $bbspath){
	global $vars;
	$str ='';
	if(file_exists($bbspath . SUBJECT_FILE)) $fp = @fopen($bbspath . SUBJECT_FILE, 'r');
	if($fp){
		while (!feof($fp)) {
			$line = fgets($fp);
			$line = explode(SPL, $line);
			if($line[0] != ''){
				$str .= '<tr><td><input type="radio" name="kdate" value="' . $line[0] . '">
				<input type="hidden" name="' . str_replace('.' . DAT, '', $line[0]) . '" value="' . $line[1] . '"></td>
				<td nowrap>' . $line[1] . ' - ' . round(filesize($bbspath. DAT . '/' . $line[0])/1000, 1)  . ' KB - 
				<a href="' . $vars['page'] . '?cmd=bbsadmin&text=' . $bbspath . DAT . '/' . $line[0] . '" target="_blank">ファイルをダウンロード</a>
				</td></tr>';
			}
		}
	}
	fclose($fp);
	if($str == ''){
		$str .= '<span style="color:#F00;font-weight:bold">立てられているスレッドがありません</span>';
	}
	else{
		$str .= '</table>';
		$str = '<table cellspacing="3"><tr><td colspan="2"><b>スレッド名</b></td></tr>' . $str;
	}
	return $str;
}

function get_comment($bbs, $bbspath, $kdate, $thread, $st = 0, $ls = 20){
	$str ='';
	if(file_exists($bbspath . DAT . '/' . $kdate)) $fp = @fopen($bbspath . DAT . '/' . $kdate, 'r');
	if($fp){
		$i = 1;
		$j = $st + $ls - 1;
		while (!feof($fp)) {
			$line = fgets($fp);
			$line = explode(SPL, $line);
			if($i >= $st && $i <= $j && $line[4] != '' ){
				$str .= '<form method="post">
				<input type="hidden" name="bbs" value="' . $bbs . '">
				<input type="hidden" name="bbspath" value="' . $bbspath . '">
				<input type="hidden" name="kdate" value="' . $kdate . '">
				<input type="hidden" name="num" value="' . $i . '">
				<input type="hidden" name="thread" value="' . $thread . '">
				<table style="border:#666 solid 1px;background:#FEFEFE;width:97%">
				<tr><td style="text-align:center">
				<input type="submit" name="action" value="修正する"></td>
				<td nowrap><b>' . $i . ": " . $line[0] . ' (' . $line[2] . ')</b></td></tr>
				<tr><td style="text-align:center;;vertical-align:top;width:10%" nowrap>';
				if($line[4] == RES) $str .= '<input type="submit" value="削除する">';
				elseif($line[4] == DELETED) $str .= '<span style="color:#060;font-weight:bold">削除済</span>';
				$str .= '</td><td>' . $line[3] . '</td>
				</tr>
				</table></form><br />';
			}
			$i++;
		}
	}
	fclose($fp);
	if($str == '') $str = '<span style="color:#F00;font-weight:bold">表示する書き込みが見つかりません。</span>';
	return $str;
}

function get_one_comment($bbs, $bbspath, $kdate, $num, $thread, $action){
	$str ='';
	if(file_exists($bbspath . DAT . '/' . $kdate)) $fp = @fopen($bbspath . DAT . '/' . $kdate, 'r');
	if($fp){
		$i = 1;
		while (!feof($fp)) {
			$line = fgets($fp);
			$line = explode(SPL, $line);
			if($i == $num){
				switch($action){
					case '':
						$str .= '<form method="post">
						<input type="hidden" name="bbs" value="' . $bbs . '">
						<input type="hidden" name="bbspath" value="' . $bbspath . '">
						<input type="hidden" name="kdate" value="' . $kdate . '">
						<input type="hidden" name="thread" value="' . $thread . '">
						<p><input type="submit" name="action" value="キャンセル"></p>
						</form>
						<hr>
						<form method="post">
						<p><input type="radio" name="default" value="1" checked>
						<b>デフォルトの消去コメント：</b>' . DELETED_COM . '</p>
						<p><input type="radio" name="default" value="0">
						<b>他のコメントに書き換える：</b><input type="text" name="dcom" size="45"></p>
						<p><input type="submit" name="action" value="この書き込みを消去する">
						<span style="color:#F00;font-weight:bold">【この操作は元に戻せません】</span></p>
						<input type="hidden" name="bbs" value="' . $bbs . '">
						<input type="hidden" name="bbspath" value="' . $bbspath . '">
						<input type="hidden" name="kdate" value="' . $kdate . '">
						<input type="hidden" name="num" value="' . $i . '">
						<input type="hidden" name="thread" value="' . $thread . '">
						<div style="border:#F00 solid 3px;background:#FCC;width:97%;padding:5px">
						<b>' . $i . ": " . $line[0] . ' (' . $line[2] . ')</b><hr>' . $line[3] . '</div></form>';
					break;
					default:
						$str .= '<form method="post">
						<input type="hidden" name="bbs" value="' . $bbs . '">
						<input type="hidden" name="bbspath" value="' . $bbspath . '">
						<input type="hidden" name="kdate" value="' . $kdate . '">
						<input type="hidden" name="thread" value="' . $thread . '">
						<p><input type="submit" name="action" value="キャンセル"></p>
						</form>
						<hr>
						<form method="post">
						<p><input type="submit" name="action" value="この書き込みを修正する">
						<span style="color:#F00;font-weight:bold">【この操作は元に戻せません】</span></p>
						<input type="hidden" name="bbs" value="' . $bbs . '">
						<input type="hidden" name="bbspath" value="' . $bbspath . '">
						<input type="hidden" name="kdate" value="' . $kdate . '">
						<input type="hidden" name="num" value="' . $i . '">
						<input type="hidden" name="thread" value="' . $thread . '">
						<input type="hidden" name="default" value="0">
						<div style="border:#F00 solid 3px;background:#FCC;width:97%;padding:5px">
						<b>' . $i . ": " . $line[0] . ' (' . $line[2] . ')</b><hr>
						<textarea name="dcom" cols="100" rows="20">' . mb_ereg_replace(BR, "\n", $line[3]) . '</textarea>
						<hr><p>' . $line[3] . '</p>
						</div></form>';
				}
				setcookie(COOKIE . '-delete', $line[3]);
				fclose($fp);
				return $str;
			}
			$i++;
		}
	} else {
		return '<span style="color:#F00;font-weight:bold">書き込みが見つかりません。</span>';
	}
}

function delete_comment($bbs, $bbspath, $kdate, $num, $dcom, $res){
	$str ='';
	if(file_exists($bbspath . DAT . '/' . $kdate)) $fp = @fopen($bbspath . DAT . '/' . $kdate, 'r');
	if($fp && flock($fp, LOCK_EX)){
		$i = 1;
		while (!feof($fp)) {
			$line = fgets($fp);
			switch($i){
			case $num:
				$line = explode(SPL, $line);
				if($line[3] == $_COOKIE[COOKIE]){
					return '<span style="color:#F00;font-weight:bold">すでに修正されています。</span>';
				} else {
					setcookie(COOKIE . '-delete', '', 0);
					if($i == 1) $res = $line[4];
					$str .= $line[0] . SPL . $line[1] . SPL . $line[2] . SPL . $dcom . TIME . SPL . $res . SPL . $line[5] . SPL . $line[6]; 
				}
			break;
			default: $str .= $line;
			}
			$i++;
		}
		flock($fp, LOCK_UN);
		fclose($fp);
		if(file_exists($bbspath . DAT . '/' . $kdate)) $fp = @fopen($bbspath . DAT . '/' . $kdate, 'w');
		flock($fp, LOCK_EX);
		fwrite($fp, $str);
		flock($fp, LOCK_UN);
		fclose($fp);
		return '<strong>修正に成功しました。</strong>';
	} else {
		return '<span style="color:#F00;font-weight:bold">修正に失敗しました。</span>';
	}
}

function delete_thread($bbspath, $kdate){
	$fp1 = @fopen($bbspath . SUBJECT_FILE, 'r');
	$fp2 = @fopen($bbspath . BACKUP_FILE, 'r');
	$str = '';
	if($fp1 && flock($fp1, LOCK_EX) && $fp2 && flock($fp2, LOCK_EX)){
		while (!feof($fp1)) {
			$line = fgets($fp1);
			$line = explode(SPL, $line);
			if($line[0] != $kdate && $line[0] != '' && $line[1] != '') $str .= $line[0] . SPL . $line[1];
		}
		flock($fp1, LOCK_UN);
		fclose($fp1);
		$fp1 = @fopen($bbspath . SUBJECT_FILE, 'w');
		flock($fp1, LOCK_EX);
		fwrite($fp1, $str);
		flock($fp2, LOCK_UN);
		unlink($bbspath . BACKUP_FILE);
		flock($fp1, LOCK_UN);
		fclose($fp1);
		copy($bbspath . SUBJECT_FILE, $bbspath . BACKUP_FILE);
		unlink($bbspath . DAT . '/' . $kdate);
		return '<strong>スレッドを削除しました。</strong>';
	} else {
		return '<span style="color:#F00;font-weight:bold">スレッドを削除できませんでした。</span>';
	}
}

function get_sqlite_version(){
	$con = sqlite_open( ':memory:', 0666, $error);
	$ver = sqlite_query( $con, 'select sqlite_version()' );
	sqlite_close( $con );
	return sqlite_fetch_single( $ver );
}

function check_db($newbbs = '', $newname = '', $path = ''){
	if( !file_exists(ADMIN_SQLITE) ) return '<span style="color:#F00;font-weight:bold">データベースに接続できませんでした。</span>';
	else {
		$i = 0;
		$con = sqlite_open(ADMIN_SQLITE, 0666, $error);
		$query = sqlite_query($con, 'SELECT PATH FROM ' . TABLE_NAME);
		while( $line = sqlite_fetch_array($query, SQLITE_NUM) ) {
			if(!file_exists($line[0])){
				sqlite_exec($con, 'DELETE FROM ' . TABLE_NAME . ' WHERE PATH="' . $line[0] . '"');
				$i = 1;
			}
		}
		$dir = dir(BBS_HOME);
		while (false !== ($line = $dir->read())) {
			if(is_dir(BBS_HOME . $line) && $line != '.' && $line != '..'){
				$query = sqlite_query($con, 'SELECT PATH FROM ' . TABLE_NAME . ' WHERE PATH="' . BBS_HOME . $line . '/" LIMIT 1');
				if(sqlite_num_rows($query) == 0){
					if($line != DAT){
						sqlite_exec($con, 'INSERT INTO ' . TABLE_NAME . ' VALUES ("' . BBS_HOME . $line . '/", "' . $line .'")');
						$i = 1;
					} elseif($line == DAT) {
						sqlite_exec($con, 'INSERT INTO ' . TABLE_NAME . ' VALUES ("' . BBS_HOME . '", "' . BBS_DIR_NAME .'")');
						$i = 1;
					}
				}
			}
		}
		$dir->close();
		sqlite_exec($con, 'VACUUM');
		sqlite_close($con);
	}
	if( $i == 1 ) return '<span style="color:#060;font-weight:bold">データベースレコードを修正しました。</span>';
	else return '<strong>異常はありませんでした。</strong>';
}

function get_conf($bbspath){
	$spl = SPL;
	$msg = '';
	include_once($bbspath . 'conf.inc.php');
	if(SPL != $spl) $msg = '<span style="color:#F00;font-weight:bold"> - bbsadmin.inc.phpとconf.inc.phpの設定が異なるので、修正が必要です。</span>'; 
	if(NGWORDmode != 0){
		$ngword = 'NGWORD = (';
		foreach(NGWORD as $ng) $ngword .= $ng . ', ';
		$ngword .= '<>';
		$ngword .= '<br />' . mb_ereg_replace(", <>",'' , $ngword) . ')';
	}
	return
	'<p>掲示板の名前(Cookieに使用)：' . BBS_NAME .
	'<br />1スレッドあたりのレス上限：' . RES_NUM .
	'<br />スレッド数の上限：' . THR_NUM .	
	'<br />ヘッドライン枠内表示数：' . HEADLINE_NUM .	
	'<br />スレッド一覧の１スレッドあたりのレス表示数：' . LS .
	'<br />ログファイルの区切り文字：' . SPL . $msg . 
	'<br />直近の書き込み内容保存数（多重書き込み対策）：' . LAST .
	'<br />ASCIIのみの書き込みを拒否する（0=拒否しない）：' . BANASCII .
	'<br />NG Wordを正規表現で指定（0=NG word機能を無効にする）：' . NGWORDmode . $ngword .
	'<br /> 名無しの名前：' . NANASHI .
	'<br />IDを表示するがどうか（0=表示しない）：' . IDmode .	
	'<br />書き込みをemailで通知するかどうか（0=しない）：' . NOTIFY . '</p>';
}
?>